# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 Nexedi SA and Contributors. All Rights Reserved.
# Copyright (c) 2006-2008 Zope Corporation and Contributors.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
##############################################################################

#
# Draft script to wrapper memcached programs calls.
# This script can be improved to provide more features
# in future.
#

from subprocess import call
import ConfigParser

def main(popenarg, conffile):
  config = ConfigParser.SafeConfigParser()
  config.read(conffile)

  args =  []

  try:
    tcp_port = config.get('memcached', 'tcp_port')
    args.extend(['-p%s' % tcp_port])
  except ConfigParser.NoOptionError:
    pass
  try:
    udp_port = config.get('memcached', 'udp_port')
    args.extend(['-U%s' % udp_port])
  except ConfigParser.NoOptionError:
    pass
  try:
    host = config.get('memcached', 'host')
    args.extend(['-l%s' % host])
  except ConfigParser.NoOptionError:
    pass
  try:
    memory_size = config.get('memcached', 'memory_size')
    args.extend(['-m%s' % memory_size])
  except ConfigParser.NoOptionError:
    pass
  try:
    simultaneous_connections = config.get('memcached', 
      'simultaneous_connections')
    args.extend(['-c%s' % simultaneous_connections])
  except ConfigParser.NoOptionError:
    pass
  try: 
    user = config.get('memcached', 'user')
    args.extend(['-u%s' % user])
  except ConfigParser.NoOptionError:
    pass
  try: 
    config.get('memcached', 'run_as_daemon')
    args.extend(['-d'])
  except ConfigParser.NoOptionError:
    pass
  try: 
    pid_file = config.get('memcached', 'pid_file')
    args.extend(['-P%s' % pid_file])
  except ConfigParser.NoOptionError:
    pass
  try: 
    factor = config.get('memcached', 'factor')
    args.extend(['-f%s' % factor])
  except ConfigParser.NoOptionError:
    pass
  try: 
    key_size = config.get('memcached', 'key_size')
    args.extend(['-n%s' % key_size])
  except ConfigParser.NoOptionError:
    pass
  try: 
    threads = config.get('memcached', 'threads')
    args.extend(['-t%s' % threads])
  except ConfigParser.NoOptionError:
    pass

  command = [popenarg]
  command.extend(args)
  print 'Running %s.' % command
  call(command)

if __name__ == "__main__":
  import sys
  main(sys.argv[1:])